package com.zskk.dicom.monitor.uploader;

import com.zskk.dicom.monitor.config.Configs;
import com.zskk.dicom.monitor.report.ErrReporter;
import com.zskk.dicom.monitor.utils.ExceptionUtil;

import java.io.File;
import java.util.concurrent.TimeUnit;
/**
 *
 * 功能描述: 老文件上传
 *
 * @param:
 * @return:
 * @auther: zzp
 * @date:
 */
public class OldUploadRunner implements Runnable{
    public OldUploadRunner() {
    }
    @Override
    public void run() {
        while(true) {
            boolean flag = upload();
            Configs.sysLog.info("--老上传队列-- System upload flag:" + flag + "\nUploadsQueue.fileQueue.size：" + UploadsQueue.fileQueue.size());
            try {
                TimeUnit.MILLISECONDS.sleep(10);
                if(UploadsQueue.fileQueue.size() == 0) {
                    Configs.sysLog.info("The old UploadQueue is empty");
                    return;
                }
                if(!flag) {
                    TimeUnit.SECONDS.sleep(1);
                }
            } catch (InterruptedException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
    }

    public synchronized static boolean upload() {
        boolean flag = false;
        try {
            // 从队列中移除已完成任务
            if(UploadsQueue.fileQueue.size() > 0) {
                System.out.println("老文件"+UploadsQueue.fileQueue.size()+"-----------------------");
                File file = UploadsQueue.fileQueue.remove(0);
                //上传
                FileUploader.upload(file);
                flag = true;
            }
        } catch (Throwable e) {
            ErrReporter.report(ExceptionUtil.getExceptionTxt(e));
            e.printStackTrace();
        }
        return flag;
    }
}
